// $Id: assistant_api.form.ui.js,v 1.2 2010/03/11 13:38:10 pounard Exp $

/**
 * @file
 * jQuery UI additions for Solace API filter form
 */

(function ($) {

Drupal.behaviors.AssistantFormUI = function(context) {
  // Attach preview dialog
  $('#assistant-api-filters-form input[name=live_preview]:not(.assistant-processed)', context).each(function() {
    new Drupal.AssistantFormPreview(this, context);
    $(this).addClass('assistant-processed');
  });
  // Attach help dialogs
  $('.help-container:not(.assistant-processed)', context).each(function() {
    new Drupal.AssistantFormHelpDialog(this);
    $(this).addClass('assistant-processed');
  });
};

Drupal.AssistantFormHelpDialog = function(element) {
  var self = this;
  // Minor fix
  $(element).css({
    'float': 'left',
    'margin-top': '3px',
  });
  this._dialog = false;
  var _description = $('.filter-description', element);
  _description.css({'display': 'none'});
  $('a:first', element).click(function() {
    if (!self._dialog) {
      self._dialog = _description;
      self._dialog.css({'display': 'block'});
      self._dialog.dialog({
        'width': 600,
        'height': 300,
        'title': Drupal.t('Help'),
        'modal': true
      });
    }
    else {
      self._dialog.dialog('open');
    }
  });
};

Drupal.AssistantFormPreview = function(element, context) {
  var self = this;
  this._dialog = false;
  $(element).click(function() {
    if (!self._dialog) {
      self._dialog = $('.assistant-dialog-main', context);
      self._dialog.dialog({
        'width': 800,
        'height': 400,
        'title': self._dialog.children('legend').html(),
        'modal': true
      });
    }
    else {
      // $('#assistant-api-filter-form-live-preview', self._dialog).html('<img src="' + Drupal.settings.basePath + 'misc/throbber.gif"/>');
      self._dialog.dialog('open');
    }
  });
};

})(jQuery);
